package com.dj.action.sys;


import org.apache.log4j.Logger;
import org.apache.struts2.convention.annotation.Action;
import org.apache.struts2.convention.annotation.Result;
import org.springframework.beans.factory.annotation.Autowired;
import com.dj.action.base.BaseAction;
import com.dj.exception.ValidateFieldsException;
import com.dj.pageModel.base.Json;
import com.dj.pageModel.sys.Attendance;
import com.dj.service.sys.AttendanceServiceI;
import com.dj.util.base.ExceptionUtil;
import com.opensymphony.xwork2.ModelDriven;

/**
 * 考勤 ACTION
 * 
 * @author lili
 * 
 */
@Action(value = "attendance", results = { @Result(name = "attendance", location = "/general/admin/attendance.jsp"), @Result(name = "attendanceEdit", location = "/general/admin/attendanceEdit.jsp") })
public class AttendanceAction extends BaseAction implements
		ModelDriven<Attendance> {

	private static final long serialVersionUID = 1L;

	private static final Logger logger = Logger
			.getLogger(AttendanceAction.class);

	private AttendanceServiceI attendanceService;

	public AttendanceServiceI getAttendanceService() {
		return attendanceService;
	}

	@Autowired
	public void setAttendanceService(AttendanceServiceI attendanceService) {
		this.attendanceService = attendanceService;
	}

	private Attendance attendance = new Attendance();

	public Attendance getModel() {
		return attendance;
	}

	public String attendance() {
		return "attendance";
	}
	
	public String attendanceEdit() {
		return "attendanceEdit";
	}

	/**
	 * 获得bug数据表格
	 */
	public void datagrid() {
		super.writeJson(attendanceService.datagrid(attendance));
	}
	
	/**
	 * 考勤编辑
	 */
	public void edit() {
		Json j = new Json();
		try {
			attendanceService.update(attendance);
			j.setSuccess(true);
			j.setMsg("编辑成功！");
		} catch (Exception e) {
			j.setMsg("编辑失败！");
		}
		super.writeJson(j);
	}
	
	//手动完成考勤
	public void finishkq() {
		Json j = new Json();
		try {
			attendanceService.finishkq(attendance.getPersoncode(),attendance.getIntime());
			j.setSuccess(true);
			j.setMsg("处理成功！");
		} catch (Exception e) {
			logger.error(ExceptionUtil.getExceptionMessage(e));
			j.setMsg("处理失败！");
		}
		super.writeJson(j);
	}

}
