package com.dj.action.sys;

import org.apache.log4j.Logger;
import org.apache.struts2.convention.annotation.Action;
import org.apache.struts2.convention.annotation.Result;
import org.springframework.beans.factory.annotation.Autowired;

import com.dj.action.base.BaseAction;
import com.dj.pageModel.base.Json;
import com.dj.pageModel.sys.Leader;
import com.dj.service.sys.LeaderServiceI;
import com.dj.util.base.ExceptionUtil;
import com.opensymphony.xwork2.ModelDriven;

/**
 * 区域ACTION
 * 
 * @author lili
 * 
 */
@Action(value = "leader", results = { @Result(name = "leader", location = "/general/admin/leader.jsp"), @Result(name = "leaderAdd", location = "/general/admin/leaderAdd.jsp"), @Result(name = "leaderEdit", location = "/general/admin/leaderEdit.jsp") })
public class LeaderAction extends BaseAction implements ModelDriven<Leader> {

	private static final long serialVersionUID = 1L;

	private static final Logger logger = Logger.getLogger(LeaderAction.class);

	private LeaderServiceI leaderService;

	public LeaderServiceI getLeaderService() {
		return leaderService;
	}

	@Autowired
	public void setLeaderService(LeaderServiceI leaderService) {
		this.leaderService = leaderService;
	}

	private Leader leader = new Leader();

	public Leader getModel() {
		return leader;
	}

	

	public String leader() {
		return "leader";
	}


	/**
	 * 用户删除
	 */
	public void delete() {
		Json j = new Json();
		leaderService.delete(leader.getIds());
		j.setSuccess(true);
		j.setMsg("删除成功!");
		super.writeJson(j);
	}

	public String leaderAdd() {
		return "leaderAdd";
	}

	public void add() {
		Json j = new Json();
		try {
			leaderService.save(leader);
			j.setSuccess(true);
			j.setMsg("添加成功！");
		} catch (Exception e) {
			logger.error(ExceptionUtil.getExceptionMessage(e));
			j.setMsg("添加失败！");
		}
		super.writeJson(j);
	}

	public String leaderEdit() {
		return "leaderEdit";
	}

	/**
	 * 编辑区域
	 */
	public void edit() {
		Json j = new Json();
		try {
			leaderService.update(leader);
			j.setSuccess(true);
			j.setMsg("编辑成功!");
		} catch (Exception e) {
			logger.error(ExceptionUtil.getExceptionMessage(e));
			j.setMsg("编辑失败！");
		}
		writeJson(j);
	}
	
	/**
	 * 获得用户datagrid
	 */
	public void datagrid() {
		super.writeJson(leaderService.datagrid(leader));
	}

}
