package com.dj.action.sys;

import com.dj.action.base.BaseAction;
import com.dj.model.sys.Vreadinfow;
import com.dj.pageModel.base.DataGrid;
import com.dj.pageModel.base.Json;
import com.dj.pageModel.sys.Readinfow;
import com.dj.service.sys.PersoninfoServiceI;
import com.dj.service.sys.ReadinfoServiceI;
import com.dj.util.base.ExceptionUtil;
import com.opensymphony.xwork2.ModelDriven;
import org.apache.log4j.Logger;
import org.apache.struts2.convention.annotation.Action;
import org.apache.struts2.convention.annotation.Result;
import org.springframework.beans.factory.annotation.Autowired;

import java.util.List;

/**
 * 人员定位 历史记录 ACTION
 *
 * @author lili
 *
 */
@Action(value = "positionpath", results = { @Result(name = "positionpath", location = "/general/admin/positionpath.jsp")})
public class PositionPathAction extends BaseAction implements ModelDriven<Readinfow> {

	private static final long serialVersionUID = 1L;

	private static final Logger logger = Logger.getLogger(PositionPathAction.class);

	private ReadinfoServiceI readinfoService;

	public ReadinfoServiceI getReadinfoService() {
		return readinfoService;
	}




	@Autowired
	public void setReadinfoService(ReadinfoServiceI readinfoService) {
		this.readinfoService = readinfoService;
	}


//	private Readinfo readinfo = new Readinfo();
	private Readinfow readinfo = new Readinfow();

	public Readinfow getModel() {
		return readinfo;
	}

	public String positionpath() {
		return "positionpath";
	}

	private String name;
	private String startDate;
	private String endDate;
	private String code ;


	public void setName(String name) {
		this.name = name;
	}

	public void setStartDate(String startDate) {
		this.startDate = startDate;
	}

	public void setEndDate(String endDate) {
		this.endDate = endDate;
	}

	public void setCode(String code) {
		this.code = code;
	}

	/**
	 * 获得bug数据表格
	 */
	public void datagrid() {
		List<Vreadinfow>  list = readinfoService.findPersonByNameAndTime(name , startDate, endDate);
		DataGrid dataGrid = new DataGrid();
		dataGrid.setTotal(Long.valueOf(list.size()));
		dataGrid.setRows(list);
		super.writeJson(dataGrid);
	}


	/**
	 * 获取人员定位实时数据
	 */
	public void realTimeData() {
		super.writeJson(readinfoService.findRealPositionRealData());
	}


	/**
	 * 获取人员定位一天内人员内的路径回放
	 */
	public void positionPathOneTimeData() {
		super.writeJson(readinfoService.positionPathOneTimeData(code));
	}

}
