package com.dj.service.sys.impl;

import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Date;
import java.util.List;

import org.apache.struts2.ServletActionContext;
import org.springframework.beans.BeanUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Propagation;
import org.springframework.transaction.annotation.Transactional;
import com.dj.dao.base.BaseDaoI;
import com.dj.model.sys.Tattendance;
import com.dj.model.sys.Vattendance;
import com.dj.pageModel.base.DataGrid;
import com.dj.pageModel.sys.Attendance;
import com.dj.service.base.impl.BaseServiceImpl;
import com.dj.service.sys.AttendanceServiceI;
import com.dj.util.base.ResourceUtil;

import com.dj.pageModel.base.SessionInfo;

@Service("attendanceService")
public class AttendanceServiceImpl extends BaseServiceImpl implements
		AttendanceServiceI {

	private BaseDaoI<Vattendance> attendanceDao;
	private BaseDaoI<Tattendance> TattendanceDao;

	public BaseDaoI<Vattendance> getAttendanceDao() {
		return attendanceDao;
	}

	@Autowired
	public void setAttendanceDao(BaseDaoI<Vattendance> attendanceDao) {
		this.attendanceDao = attendanceDao;
	}

	public BaseDaoI<Tattendance> getTattendanceDao() {
		return TattendanceDao;
	}

	@Autowired
	public void setTattendanceDao(BaseDaoI<Tattendance> tattendanceDao) {
		TattendanceDao = tattendanceDao;
	}

	@Transactional(readOnly = true, propagation = Propagation.SUPPORTS)
	public DataGrid datagrid(Attendance attendance) {
		DataGrid j = new DataGrid();
		j.setRows(changeModel(find(attendance)));
		j.setTotal(total(attendance));
		return j;
	}
	
	
	//根据人员编号和时间修改考勤
	public void finishkq(Integer personcode,Date intime)
	{
		
		//System.out.println(personcode);
		//System.out.println(intime);
		//Date 转化为  String
		SimpleDateFormat sdf = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss");
		String outtime = sdf.format(new Date());
		String sintime = sdf.format(intime);
		
		//to_char(a.readtime, 'yyyy-mm-dd hh24:mi:ss'::text)
		TattendanceDao.executeHql("update Tattendance set flag = '3',outtime = '" + outtime + "' where personcode = " + personcode + " and to_char(intime,'yyyy-mm-dd hh24:mi:ss') = '" + sintime + "'");
	}

	private List<Attendance> changeModel(List<Vattendance> tattendances) {
		List<Attendance> attendances = new ArrayList<Attendance>();
		if (tattendances != null && tattendances.size() > 0) {
			for (Vattendance tb : tattendances) {
				Attendance b = new Attendance();
				BeanUtils.copyProperties(tb, b);
				// b.setId(tb.getId());
				// b.setPersoncode(tb.getPersoncode());
				// b.setPersonname(tb.getPersonname());
				// b.setIntime(tb.getIntime());
				// b.setOuttime(tb.getOuttime());

				attendances.add(b);
			}
		}
		return attendances;
	}

	private List<Vattendance> find(Attendance attendance) {
		
		
		SessionInfo sessionInfo = (SessionInfo) ServletActionContext.getRequest().getSession().getAttribute(ResourceUtil.getSessionInfoName());
		//得到矿区
		String mineareacode = sessionInfo.getMineareacode();
					
		//得到矿区
		List<Object> values = new ArrayList<Object>();
		String hql = "";
		
		
		if("0".equals(mineareacode))
		{
			hql = "from Vattendance t where 1=1 ";
		}
		else
		{
			hql = "from Vattendance t where t.mineareacode = ?";
			values.add(mineareacode);
		}
		// lili 2015-03-23
		
		hql = addWhere(attendance, hql, values);

		if (attendance.getSort() != null && attendance.getOrder() != null) {
			hql += " order by " + attendance.getSort() + " "
					+ attendance.getOrder();
		}
		return attendanceDao.find(hql, values, attendance.getPage(),
				attendance.getRows());
	}

	// private List find(Attendance attendance)
	// {
	// String hql =
	// "select t.id,t.personcode,t.intime,t.outtime,t1.personname from Vattendance t left join t.tpersoninfo t1 where 1=1";
	// List<Object> values = new ArrayList<Object>();
	// hql = addWhere(attendance, hql, values);
	//
	// if (attendance.getSort() != null && attendance.getOrder() != null) {
	// hql += " order by " + attendance.getSort() + " " + attendance.getOrder();
	// }
	// return attendanceDao.find(hql, values, attendance.getPage(),
	// attendance.getRows());
	// }

	private Long total(Attendance attendance) {
		
		SessionInfo sessionInfo = (SessionInfo) ServletActionContext.getRequest().getSession().getAttribute(ResourceUtil.getSessionInfoName());
		//得到矿区
		String mineareacode = sessionInfo.getMineareacode();
		
		List<Object> values = new ArrayList<Object>();
		
		String hql = "";
		if("0".equals(mineareacode))
		{
			hql = "select count(*) from Vattendance t where 1=1 ";
		}
		else
		{
			hql = "select count(*) from Vattendance t where t.mineareacode = ?";
			values.add(mineareacode);
		}
		// lili 2015-03-23
		
		
		hql = addWhere(attendance, hql, values);
		return attendanceDao.count(hql, values);
	}

	private String addWhere(Attendance attendance, String hql,
			List<Object> values) {
		if (attendance.getPersoncode() != null
				&& attendance.getPersoncode() > 0) {
			hql += " and t.personcode = ?";
			values.add(attendance.getPersoncode());
		}
		
		if (attendance.getPersonname() != null
				&& !"".equals(attendance.getPersonname())) {
			hql += " and t.personname = ?";
			values.add(attendance.getPersonname());
		}

		if (attendance.getIntimeStart() != null) {
			hql += " and t.intime>=? ";
			values.add(attendance.getIntimeStart());
		}
		if (attendance.getIntimeEnd() != null) {
			hql += " and t.intime<=? ";
			values.add(attendance.getIntimeEnd());
		}
		if (attendance.getOuttimeStart() != null) {
			hql += " and t.outtime>=? ";
			values.add(attendance.getOuttimeStart());
		}
		if (attendance.getOuttimeEnd() != null) {
			hql += " and t.outtime<=? ";
			values.add(attendance.getOuttimeEnd());
		}
		if (attendance.getMineareacode() != null
				&& !attendance.getMineareacode().trim().equals("")) {
			hql += " and t.mineareacode = ?";
			values.add(attendance.getMineareacode());
		}

		if (attendance.getDepartcode() != null
				&& !attendance.getDepartcode().trim().equals("")) {
			hql += " and t.departcode = ?";
			values.add(attendance.getDepartcode());
		}
		return hql;
	}
	
	public void update(Attendance attendance) {
		Tattendance t = TattendanceDao.get(Tattendance.class, attendance.getId());
		if (t != null) {
			t.setPersoncode(attendance.getPersoncode());
			t.setPersonname(attendance.getPersonname());
			t.setIntime(attendance.getIntime());
			t.setOuttime(attendance.getOuttime());
						
			

		}
	}

}
