package com.dj.service.sys.impl;

import java.util.ArrayList;
import java.util.List;
import java.util.UUID;

import org.springframework.beans.BeanUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Propagation;
import org.springframework.transaction.annotation.Transactional;

import com.dj.dao.base.BaseDaoI;

import com.dj.model.sys.Tminearea;
import com.dj.model.sys.Tconfig;
import com.dj.pageModel.base.DataGrid;
import com.dj.pageModel.sys.Config;
import com.dj.service.base.impl.BaseServiceImpl;

import com.dj.service.sys.ConfigServiceI;


@Service("configService")
public class ConfigServiceImpl extends BaseServiceImpl implements ConfigServiceI {

	private BaseDaoI<Tconfig> configDao;


	public BaseDaoI<Tconfig> getConfigDao() {
		return configDao;
	}

	@Autowired
	public void setConfigDao(BaseDaoI<Tconfig> configDao) {
		this.configDao = configDao;
	}
	


	@Transactional(readOnly = true, propagation = Propagation.SUPPORTS)
	public DataGrid datagrid(Config config) {
		DataGrid j = new DataGrid();
		j.setRows(changeModel(find(config)));
		j.setTotal(total(config));
		return j;
	}

	private List<Config> changeModel(List<Tconfig> tconfigs) {
		List<Config> configs = new ArrayList<Config>();
		if (tconfigs != null && tconfigs.size() > 0) {
			for (Tconfig tb : tconfigs) {
				Config b = new Config();
			
			
				b.setId(tb.getId());
				b.setOvertime(tb.getOvertime());

			
				configs.add(b);
			}
		}
		return configs;
	}

	private List<Tconfig> find(Config config) {
		//String hql = "select new Tconfig(t.cid,t.cname,t.caddr,t.ctype,t.cxpos,t.cypos,t.czpos,t.cremark) from Tconfig t where 1=1 ";
		String hql = "from Tconfig t where 1=1";

		List<Object> values = new ArrayList<Object>();
		hql = addWhere(config, hql, values);

		if (config.getSort() != null && config.getOrder() != null) {
			hql += " order by " + config.getSort() + " " + config.getOrder();
		}
		return configDao.find(hql, values, config.getPage(), config.getRows());
	}

	private Long total(Config config) {
		String hql = "select count(*) from Tconfig t where 1=1 ";
		List<Object> values = new ArrayList<Object>();
		hql = addWhere(config, hql, values);
		return configDao.count(hql, values);
	}

	private String addWhere(Config config, String hql, List<Object> values) {
		return hql;
	}

	public void delete(String ids) {
		if (ids != null) {
			for (String id : ids.split(",")) {
				Tconfig t = configDao.get(Tconfig.class, id);
				if (t != null) {
					configDao.delete(t);
				}
			}
		}
	}

	public void add(Config config) {
		
		Tconfig t = new Tconfig();
		BeanUtils.copyProperties(config, t);
		t.setId(UUID.randomUUID().toString());
		
		configDao.save(t);
	}



	public void update(Config config) {
		Tconfig t = configDao.get(Tconfig.class, config.getId());
		if (t != null) {
		t.setOvertime(config.getOvertime());
			
			

		}
	}

}
