package com.dj.service.sys.impl;

import java.util.ArrayList;
import java.util.Calendar;
import java.util.Date;
import java.util.GregorianCalendar;
import java.util.List;

import org.apache.struts2.ServletActionContext;
import org.springframework.beans.BeanUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Propagation;
import org.springframework.transaction.annotation.Transactional;
import com.dj.dao.base.BaseDaoI;
import com.dj.model.sys.Vattendance;
import com.dj.pageModel.base.DataGrid;
import com.dj.pageModel.sys.Attendance;
import com.dj.service.base.impl.BaseServiceImpl;
import com.dj.service.sys.PerAttendanceServiceI;
import com.dj.util.base.ResourceUtil;

import com.dj.pageModel.base.SessionInfo;

@Service("perattendanceService")
public class PerAttendanceServiceImpl extends BaseServiceImpl implements
		PerAttendanceServiceI {

	private BaseDaoI<Vattendance> attendanceDao;

	public BaseDaoI<Vattendance> getAttendanceDao() {
		return attendanceDao;
	}

	@Autowired
	public void setAttendanceDao(BaseDaoI<Vattendance> attendanceDao) {
		this.attendanceDao = attendanceDao;
	}

	@Transactional(readOnly = true, propagation = Propagation.SUPPORTS)
	public DataGrid datagrid(Attendance attendance) {
		DataGrid j = new DataGrid();
		j.setRows(changeModel(find(attendance)));
		j.setTotal(total(attendance));
		return j;
	}

	private List<Attendance> changeModel(List<Vattendance> tattendances) {
		List<Attendance> attendances = new ArrayList<Attendance>();
		if (tattendances != null && tattendances.size() > 0) {
			for (Vattendance tb : tattendances) {
				Attendance b = new Attendance();
				BeanUtils.copyProperties(tb, b);
				// b.setId(tb.getId());
				// b.setPersoncode(tb.getPersoncode());
				// b.setPersonname(tb.getPersonname());
				// b.setIntime(tb.getIntime());
				// b.setOuttime(tb.getOuttime());

				attendances.add(b);
			}
		}
		return attendances;
	}

	private List<Vattendance> find(Attendance attendance) {

		SessionInfo sessionInfo = (SessionInfo) ServletActionContext
				.getRequest().getSession()
				.getAttribute(ResourceUtil.getSessionInfoName());
		// 得到矿区
		String mineareacode = sessionInfo.getMineareacode();

		List<Object> values = new ArrayList<Object>();

		String hql = "";

		if ("0".equals(mineareacode)) {
			hql = "from Vattendance t where 1=1 ";
		} else {
			hql = "from Vattendance t where t.mineareacode = ?";
			values.add(mineareacode);
		}
		
		// lili 2015-03-23
		

		hql = addWhere(attendance, hql, values);

		if (attendance.getSort() != null && attendance.getOrder() != null) {
			hql += " order by " + attendance.getSort() + " "
					+ attendance.getOrder();
		}
		return attendanceDao.find(hql, values, attendance.getPage(),
				attendance.getRows());
	}

	private Long total(Attendance attendance) {
		
		SessionInfo sessionInfo = (SessionInfo) ServletActionContext.getRequest().getSession().getAttribute(ResourceUtil.getSessionInfoName());
		//得到矿区
		String mineareacode = sessionInfo.getMineareacode();
		
		List<Object> values = new ArrayList<Object>();
		
		String hql = "";
		if("0".equals(mineareacode))
		{
			hql = "select count(*) from Vattendance t where 1=1 ";
		}
		else
		{
			hql = "select count(*) from Vattendance t where t.mineareacode = ?";
			values.add(mineareacode);
		}
		
		// lili 2015-03-23
		
		
		hql = addWhere(attendance, hql, values);
		return attendanceDao.count(hql, values);
	}

	private String addWhere(Attendance attendance, String hql,
			List<Object> values) {
		if (attendance.getPersoncode() != null
				&& attendance.getPersoncode() > 0) {
			hql += " and t.personcode = ?";
			values.add(attendance.getPersoncode());
		}

		if (attendance.getPersonname() != null
				&& !"".equals(attendance.getPersonname())) {
			hql += " and t.personname = ?";
			values.add(attendance.getPersonname());
		}

		// 查询日期起

		if (attendance.getIntimeStart() != null) {
			hql += " and t.intime>=?";
			Date intime1 = attendance.getIntimeStart();
			values.add(intime1);

		}

		// 查询日期止
		if (attendance.getIntimeEnd() != null) {
			hql += " and t.intime<?";
			Date intime1 = attendance.getIntimeEnd();
			Date intime2 = null;

			Calendar calendar = new GregorianCalendar();
			calendar.setTime(intime1);
			calendar.add(calendar.DATE, 1);// 把日期往后增加一天.整数往后推,负数往前移动
			intime2 = calendar.getTime(); // 这个时间就是日期往后推一天的结果
			values.add(intime2);
		}

		if (attendance.getMineareacode() != null
				&& !attendance.getMineareacode().trim().equals("")) {
			hql += " and t.mineareacode = ?";
			values.add(attendance.getMineareacode());
		}

		if (attendance.getDepartcode() != null
				&& !attendance.getDepartcode().trim().equals("")) {
			hql += " and t.departcode = ?";
			values.add(attendance.getDepartcode());
		}
		return hql;
	}

}
