package com.dj.service.sys.impl;

import java.util.ArrayList;
import java.util.List;

import com.dj.model.sys.Treadinfo;
import org.hibernate.Query;
import org.hibernate.Session;
import org.hibernate.SessionFactory;
import org.springframework.beans.BeanUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Propagation;
import org.springframework.transaction.annotation.Transactional;
import com.dj.dao.base.BaseDaoI;
import com.dj.model.sys.Vreadinfow;

import com.dj.pageModel.base.DataGrid;
import com.dj.pageModel.sys.Readinfow;
import com.dj.service.base.impl.BaseServiceImpl;
import com.dj.service.sys.ReadinfoServiceI;


@Service("readinfoService")
public class ReadinfoServiceImpl extends BaseServiceImpl implements ReadinfoServiceI {
	private SessionFactory sessionFactory;

	public SessionFactory getSessionFactory() {
		return sessionFactory;
	}

	@Autowired
	public void setSessionFactory(SessionFactory sessionFactory) {
		this.sessionFactory = sessionFactory;
	}

	private Session getCurrentSession() {
		return sessionFactory.getCurrentSession();
	}


	private BaseDaoI<Vreadinfow> readinfoDao;

	public BaseDaoI<Vreadinfow> getReadinfoDao() {
		return readinfoDao;
	}

	@Autowired
	public void setReadinfoDao(BaseDaoI<Vreadinfow> readinfoDao) {
		this.readinfoDao = readinfoDao;
	}

	@Transactional(readOnly = true, propagation = Propagation.SUPPORTS)
	public DataGrid datagrid(Readinfow readinfo) {
		DataGrid j = new DataGrid();
		j.setRows(changeModel(find(readinfo)));
		j.setTotal(total(readinfo));
		return j;
	}

	private List<Readinfow> changeModel(List<Vreadinfow> treadinfos) {
		List<Readinfow> readinfos = new ArrayList<Readinfow>();
		if (treadinfos != null && treadinfos.size() > 0) {
			for (Vreadinfow tb : treadinfos) {
				Readinfow b = new Readinfow();
				BeanUtils.copyProperties(tb, b);
				readinfos.add(b);
			}
		}
		return readinfos;
	}

	private List<Vreadinfow> find(Readinfow readinfo) {
		String hql = " from Vreadinfow t where 1=1 ";
		List<Object> values = new ArrayList<Object>();
		hql = addWhere(readinfo, hql, values);
		if (readinfo.getSort() != null && readinfo.getOrder() != null) {
			hql += " order by " + readinfo.getSort() + " " + readinfo.getOrder();
		}
		return readinfoDao.find(hql, values, readinfo.getPage(), readinfo.getRows());
	}

	private Long total(Readinfow readinfo) {
		String hql = "select count(*) from Vreadinfow t where 1=1 ";
		List<Object> values = new ArrayList<Object>();
		hql = addWhere(readinfo, hql, values);
		return readinfoDao.count(hql, values);
	}

	private String addWhere(Readinfow readinfo, String hql, List<Object> values) {

		//卡号
		if(readinfo.getZddz() != null && !"".equals(readinfo.getZddz().trim()))
		{

			hql += " and t.zddz = ?";
			values.add(readinfo.getZddz().trim());

		}
		//人员编号
		if(readinfo.getPersoncode() !=null )
		{
			hql += " and t.personcode = ?";
			values.add(readinfo.getPersoncode());

		}

		if(readinfo.getPersonname() !=null && !"".equals(readinfo.getPersonname().trim()))
		{
			hql += " and t.personname like ? ";
			values.add("%%" + readinfo.getPersonname().trim() + "%%");

		}
		//增加矿区、人员姓名查询
		if (readinfo.getReadtimeStart()  != null && !"".equals(readinfo.getReadtimeStart().trim())) {
			hql += " and t.readtime>=? ";
			values.add(readinfo.getReadtimeStart());
		}
		if (readinfo.getReadtimeEnd()  != null && !"".equals(readinfo.getReadtimeEnd().trim())) {
			hql += " and t.readtime<=? ";
			values.add(readinfo.getReadtimeEnd() );
		}
		return hql;
	}


	public void update(Readinfow readinfo) {
		Vreadinfow t = readinfoDao.get(Vreadinfow.class, readinfo.getId());
		if (t != null) {
//			t.setCardcode(readinfo.getCardcode());
//			t.setSenid(readinfo.getSenid());
//			t.setType(readinfo.getType());
//			t.setDl(readinfo.getDl());
//			t.setRssi(readinfo.getRssi());
//			t.setState(readinfo.getState());
			//t.setReadtime(readinfo.getReadtime());
		}
	}

	@Override
	public List<Vreadinfow>  findPersonByNameAndTime(String name, String start, String end) {
		String hql = "from Vreadinfow t where 1=1 ";
		List<Object> values = new ArrayList<Object>();
		hql = hql + " and zddz = '"+name+"' and readtime between '"+start+"' and '"+end+"'";
		return readinfoDao.find(hql);
	}


	@Override
	public List findRealPositionRealData() {
		String hql = "select id,personcode, personname, senid, zddz, readtime, layer, outtime from (select id, personcode, personname, senid, zddz, readtime , outtime, layer, rank() over (PARTITION BY zddz ORDER BY readtime DESC) r"+
				" from v_readinfo_w1  ) a where a.r = 1"+
				" and to_timestamp(readtime,  'YYYY-MM-DD HH24:MI:SS') > (cast(now() as TIMESTAMP) - interval '6 hour')";
		Query  query = this.getCurrentSession().createSQLQuery(hql).addEntity(Vreadinfow.class);
		return query.list();
	}


	@Override
	public List positionPathOneTimeData(String personcode) {
		String hql = "select * from v_readinfo_w1 where zddz = '" + personcode + "' "+
				"and to_timestamp(readtime,  'YYYY-MM-DD HH24:MI:SS') < now() " +
				"and to_timestamp(readtime,  'YYYY-MM-DD HH24:MI:SS') > to_timestamp(to_char(now(), 'YYYY-MM-DD')||' 00:00:00','YYYY-MM-DD HH24:MI:SS')";

		Query query = this.getCurrentSession().createSQLQuery(hql).addEntity(Vreadinfow.class);
		return query.list();
	}
}
