package com.dj.service.sys.impl;

import java.util.ArrayList;
import java.util.List;
import org.springframework.beans.BeanUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Propagation;
import org.springframework.transaction.annotation.Transactional;
import com.dj.dao.base.BaseDaoI;
import com.dj.model.sys.Vrfcardw;

import com.dj.pageModel.base.DataGrid;
import com.dj.pageModel.sys.Rfcardw;
import com.dj.service.base.impl.BaseServiceImpl;
import com.dj.service.sys.RfcardServiceI;


@Service("rfcardService")
public class RfcardServiceImpl extends BaseServiceImpl implements RfcardServiceI {

	private BaseDaoI<Vrfcardw> rfcardDao;

	public BaseDaoI<Vrfcardw> getRfcardDao() {
		return rfcardDao;
	}

	@Autowired
	public void setRfcardDao(BaseDaoI<Vrfcardw> rfcardDao) {
		this.rfcardDao = rfcardDao;
	}

	@Transactional(readOnly = true, propagation = Propagation.SUPPORTS)
	public DataGrid datagrid(Rfcardw rfcard) {
		DataGrid j = new DataGrid();
		j.setRows(changeModel(find(rfcard)));
		j.setTotal(total(rfcard));
		return j;
	}

	private List<Rfcardw> changeModel(List<Vrfcardw> trfcards) {
		List<Rfcardw> rfcards = new ArrayList<Rfcardw>();
		if (trfcards != null && trfcards.size() > 0) {
			for (Vrfcardw tb : trfcards) {
				Rfcardw b = new Rfcardw();
				BeanUtils.copyProperties(tb, b);
				rfcards.add(b);
			}
		}
		return rfcards;
	}

	private List<Vrfcardw> find(Rfcardw rfcard) {
		String hql = " from Vrfcardw t where 1=1 ";

		List<Object> values = new ArrayList<Object>();
		hql = addWhere(rfcard, hql, values);

		if (rfcard.getSort() != null && rfcard.getOrder() != null) {
			hql += " order by " + rfcard.getSort() + " " + rfcard.getOrder();
		}
		return rfcardDao.find(hql, values, rfcard.getPage(), rfcard.getRows());
	}

	private Long total(Rfcardw rfcard) {
		String hql = "select count(*) from Vrfcardw t where 1=1 ";
		List<Object> values = new ArrayList<Object>();
		hql = addWhere(rfcard, hql, values);
		return rfcardDao.count(hql, values);
	}

	private String addWhere(Rfcardw rfcard, String hql, List<Object> values) {
		
		
		//卡号
		if(rfcard.getZddz() !=null && !"".equals(rfcard.getZddz().trim()))			
		{
			
			hql += " and t.zddz = ?";
			values.add(rfcard.getZddz().trim());
			
		}
		//人员编号
		if(rfcard.getPersoncode() !=null )
		{
			hql += " and t.personcode = ?";
			values.add(rfcard.getPersoncode());
			
		}
		if(rfcard.getMineareacode() !=null && !"".equals(rfcard.getMineareacode().trim()))
		{
			hql += " and t.mineareacode like ? ";
			values.add("%%" + rfcard.getMineareacode().trim() + "%%");
			
		}
		if(rfcard.getPersonname() !=null && !"".equals(rfcard.getPersonname().trim()))
		{
			hql += " and t.personname like ? ";
			values.add("%%" + rfcard.getPersonname().trim() + "%%");
			
		}
		//增加矿区、人员姓名查询
		if (rfcard.getReadtimeStart()  != null && !"".equals(rfcard.getReadtimeStart().trim())) {
			hql += " and t.readtime>=? ";
			values.add(rfcard.getReadtimeStart());
		}
		if (rfcard.getReadtimeEnd()  != null && !"".equals(rfcard.getReadtimeEnd().trim())) {
			hql += " and t.readtime<=? ";
			values.add(rfcard.getReadtimeEnd() );
		}
		return hql;
	}


	public void update(Rfcardw rfcard) {
		Vrfcardw t = rfcardDao.get(Vrfcardw.class, rfcard.getId());
		if (t != null) {
//			t.setCardcode(rfcard.getCardcode());
//			t.setSenid(rfcard.getSenid());
//			t.setType(rfcard.getType());
//			t.setDl(rfcard.getDl());
//			t.setRssi(rfcard.getRssi());
//			t.setState(rfcard.getState());
			//t.setReadtime(rfcard.getReadtime());
			
			

		}
	}

}
