package com.dj.service.sys.impl;

import java.util.ArrayList;
import java.util.List;
import org.springframework.beans.BeanUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Propagation;
import org.springframework.transaction.annotation.Transactional;
import com.dj.dao.base.BaseDaoI;
import com.dj.model.sys.Tsensor;
import com.dj.pageModel.base.DataGrid;
import com.dj.pageModel.sys.Sensor;
import com.dj.service.base.impl.BaseServiceImpl;

import com.dj.service.sys.SensorServiceI;


@Service("sensorService")
public class SensorServiceImpl extends BaseServiceImpl implements SensorServiceI {

	private BaseDaoI<Tsensor> sensorDao;

	public BaseDaoI<Tsensor> getSensorDao() {
		return sensorDao;
	}

	@Autowired
	public void setSensorDao(BaseDaoI<Tsensor> sensorDao) {
		this.sensorDao = sensorDao;
	}

	@Transactional(readOnly = true, propagation = Propagation.SUPPORTS)
	public DataGrid datagrid(Sensor sensor) {
		DataGrid j = new DataGrid();
		j.setRows(changeModel(find(sensor)));
		j.setTotal(total(sensor));
		return j;
	}

	private List<Sensor> changeModel(List<Tsensor> tsensors) {
		List<Sensor> sensors = new ArrayList<Sensor>();
		if (tsensors != null && tsensors.size() > 0) {
			for (Tsensor tb : tsensors) {
				Sensor b = new Sensor();
				BeanUtils.copyProperties(tb, b);
				sensors.add(b);
			}
		}
		return sensors;
	}

	private List<Tsensor> find(Sensor sensor) {
		//select new Tsensor(t.id) ,t.kind,t.state,t.mark,t.name,t.zkbh,t.address1,t.address2,t.addressb,t.bzuobiao,t.czuobiao,t.angle,t.alarmvalue,t.values1,t.notalarmvalue,t.jiazhichushi,t.programid
		String hql = "select new Tsensor(t.id,t.kind,t.state,t.mark,t.name,t.zkbh,t.address1,t.address2,t.addressb,t.bzuobiao,t.czuobiao,t.angle,t.alarmvalue,t.values1,t.notalarmvalue,t.jiazhichushi,t.programid,t.mineareacode) from Tsensor t where 1=1 ";

		List<Object> values = new ArrayList<Object>();
		hql = addWhere(sensor, hql, values);

		if (sensor.getSort() != null && sensor.getOrder() != null) {
			hql += " order by " + sensor.getSort() + " " + sensor.getOrder();
		}
		return sensorDao.find(hql, values, sensor.getPage(), sensor.getRows());
	}

	private Long total(Sensor sensor) {
		String hql = "select count(*) from Tsensor t where 1=1 ";
		List<Object> values = new ArrayList<Object>();
		hql = addWhere(sensor, hql, values);
		return sensorDao.count(hql, values);
	}

	private String addWhere(Sensor sensor, String hql, List<Object> values) {
		return hql;
	}

	public void delete(String ids) {
		if (ids != null) {
			for (String id : ids.split(",")) {
				Tsensor t = sensorDao.get(Tsensor.class, Integer.parseInt(id));
				if (t != null) {
					sensorDao.delete(t);
				}
			}
		}
	}

	public void add(Sensor sensor) {
		
		Tsensor t = new Tsensor();
		BeanUtils.copyProperties(sensor, t);
		//取得最大值 加1
		String hql = "select max(id) from Tsensor t where 1=1";
		long max = sensorDao.max(hql);
		
		t.setId((int)(max+1));
		sensorDao.save(t);
	}



	public void update(Sensor sensor) {
		Tsensor t = sensorDao.get(Tsensor.class, sensor.getId());
		if (t != null) {
			
			t.setKind(sensor.getKind());
			t.setState(sensor.getState());
			t.setMark(sensor.getMark());
			t.setName(sensor.getName());
			t.setZkbh(sensor.getZkbh());
			t.setAddress1(sensor.getAddress1());
			t.setAddress2(sensor.getAddress2());
			t.setAddressb(sensor.getAddressb());
			t.setBzuobiao(sensor.getBzuobiao());
			t.setCzuobiao(sensor.getCzuobiao());
			t.setAngle(sensor.getAngle());
			t.setAlarmvalue(sensor.getAlarmvalue());
			t.setValues1(sensor.getValues1());
			t.setNotalarmvalue(sensor.getNotalarmvalue());
			t.setJiazhichushi(sensor.getJiazhichushi());
			t.setProgramid(sensor.getProgramid());
			t.setMineareacode(sensor.getMineareacode());
			

		}
	}

}
