package com.dj.service.sys.impl;

import java.util.ArrayList;
import java.util.Calendar;
import java.util.Date;
import java.util.GregorianCalendar;
import java.util.List;

import org.springframework.beans.BeanUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Propagation;
import org.springframework.transaction.annotation.Transactional;

import com.dj.dao.base.BaseDaoI;


import com.dj.model.sys.Tworktimeout;
import com.dj.model.sys.Vworktimeout;
import com.dj.pageModel.base.DataGrid;
import com.dj.pageModel.sys.Worktimeout;
import com.dj.service.base.impl.BaseServiceImpl;

import com.dj.service.sys.WorktimeoutServiceI;


@Service("worktimeoutService")
public class WorktimeoutServiceImpl extends BaseServiceImpl implements WorktimeoutServiceI {

	private BaseDaoI<Tworktimeout> worktimeoutDao;
	private BaseDaoI<Vworktimeout> vworktimeoutDao;


	public BaseDaoI<Tworktimeout> getWorktimeoutDao() {
		return worktimeoutDao;
	}
	@Autowired
	public void setWorktimeoutDao(BaseDaoI<Tworktimeout> worktimeoutDao) {
		this.worktimeoutDao = worktimeoutDao;
	}
	
	public BaseDaoI<Vworktimeout> getVworktimeoutDao() {
		return vworktimeoutDao;
	}
	@Autowired
	public void setVworktimeoutDao(BaseDaoI<Vworktimeout> vworktimeoutDao) {
		this.vworktimeoutDao = vworktimeoutDao;
	}
	
	@Transactional(readOnly = true, propagation = Propagation.SUPPORTS)
	public DataGrid datagrid(Worktimeout worktimeout) {
		DataGrid j = new DataGrid();
		j.setRows(changeModel(find(worktimeout)));
		j.setTotal(total(worktimeout));
		return j;
	}

	private List<Worktimeout> changeModel(List<Vworktimeout> tworktimeouts) {
		List<Worktimeout> worktimeouts = new ArrayList<Worktimeout>();
		if (tworktimeouts != null && tworktimeouts.size() > 0) {
			for (Vworktimeout tb : tworktimeouts) {
				Worktimeout b = new Worktimeout();						
				BeanUtils.copyProperties(tb, b);						
				worktimeouts.add(b);
			}
		}
		return worktimeouts;
	}

	private List<Vworktimeout> find(Worktimeout worktimeout) {
		
		String hql = "from Vworktimeout t where 1=1";

		List<Object> values = new ArrayList<Object>();
		hql = addWhere(worktimeout, hql, values);

		if (worktimeout.getSort() != null && worktimeout.getOrder() != null) {
			hql += " order by " + worktimeout.getSort() + " " + worktimeout.getOrder();
		}
		return vworktimeoutDao.find(hql, values, worktimeout.getPage(), worktimeout.getRows());
	}

	private Long total(Worktimeout worktimeout) {
		String hql = "select count(*) from Vworktimeout t where 1=1 ";
		List<Object> values = new ArrayList<Object>();
		hql = addWhere(worktimeout, hql, values);
		return vworktimeoutDao.count(hql, values);
	}

	private String addWhere(Worktimeout worktimeout, String hql, List<Object> values) {
		if (worktimeout.getPersoncode() != null
				&& worktimeout.getPersoncode() > 0) {
			hql += " and t.personcode = ?";
			values.add(worktimeout.getPersoncode());
		}

		if (worktimeout.getPersonname() != null
				&& !"".equals(worktimeout.getPersonname())) {
			hql += " and t.personname = ?";
			values.add(worktimeout.getPersonname());
		}

		// 入井时间

		if (worktimeout.getIntimeStart() != null) {
			hql += " and (t.intime>=? and t.intime<?)";
			Date intime1 = worktimeout.getIntimeStart();
			Date intime2 = null;

			Calendar calendar = new GregorianCalendar();
			calendar.setTime(intime1);
			calendar.add(calendar.DATE, 1);// 把日期往后增加一天.整数往后推,负数往前移动
			intime2 = calendar.getTime(); // 这个时间就是日期往后推一天的结果

			values.add(intime1);
			values.add(intime2);
		}

		if (worktimeout.getMineareacode() != null
				&& !worktimeout.getMineareacode().trim().equals("")) {
			hql += " and t.mineareacode = ?";
			values.add(worktimeout.getMineareacode());
		}

		if (worktimeout.getDepartcode() != null
				&& !worktimeout.getDepartcode().trim().equals("")) {
			hql += " and t.departcode = ?";
			values.add(worktimeout.getDepartcode());
		}
		if (worktimeout.getHandle() != null
				&& !worktimeout.getHandle().trim().equals("")) {
			hql += " and t.handle = ?";
			values.add(worktimeout.getHandle());
		}
		
		if (worktimeout.getFlag() != null
				&& !worktimeout.getFlag().trim().equals("")) {
			if("0".equals(worktimeout.getFlag()))
			{
				hql += " and t.flag = '0'";
			}
			else
			{
				hql += " and t.flag != '0'";
			}
			
			
		}
		return hql;
	}

	//1  为 加班
	//hql支持三种  current_date  current_time  current_timestamp
	public void addtime(String ids) {
		if (ids != null) {
			for (String id : ids.split(",")) {
				//可以直接执行sql
				worktimeoutDao.executeHql("update Tworktimeout set handle='加班',handletime=current_timestamp(),  flag = '1' where id = " + id);
			}
		}
	}
	
	//2 为漏卡
	public void miss(String ids) {
		if (ids != null) {
			for (String id : ids.split(",")) {
				worktimeoutDao.executeHql("update Tworktimeout set handle='漏卡',handletime=current_timestamp(),flag = '2' where id = " + id);
			}
		}
	}
	
	//3 为忽略
	public void ignore(String ids) {
		if (ids != null) {
			for (String id : ids.split(",")) {
				worktimeoutDao.executeHql("update Tworktimeout set handle='忽略',handletime=current_timestamp(),flag = '3' where id = " + id);
			}
		}
	}



}
